package defs

import "github.com/golang-jwt/jwt/v5"

type UserGettable interface {
	GetUserID() int64
	GetAppleUserID() string
	GetName() string
	GetUsername() string
	GetEmail() string
	GetIsPrivateEmail() bool
	GetEmailVerified() bool
	FromJWTClaims(jwt.MapClaims)
	ToUser() User
	ToMap() map[string]string
}
